/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2005,2006 NoMachine, http://www.nomachine.com.           */
/*                                                                        */
/* NXBUILDER, NX protocol compression and NX extensions to this software  */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rigths reserved.                                                   */
/*                                                                        */
/**************************************************************************/

//
// Check the site from which to download the NX Client in relation to the O.S.
//
function siteDownload()
{
  if(navigator.userAgent.toLowerCase().indexOf("windows") != -1)
    this.document.getElementById('NoMachineLink').href = 'http://www.nomachine.com/download-client-windows.php';
  else if((navigator.userAgent.toLowerCase().indexOf("linux") != -1) || (navigator.userAgent.indexOf("Unix") != -1))
    this.document.getElementById('NoMachineLink').href = 'http://www.nomachine.com/download-client-linux.php';
  else if(navigator.userAgent.toLowerCase().indexOf("mac") != -1)
    this.document.getElementById('NoMachineLink').href = 'http://www.nomachine.com/download-client-macosx.php';
  else if ((navigator.userAgent.toLowerCase().indexOf("solaris") != -1) || (navigator.userAgent.toLowerCase().indexOf("sunos") != -1))
    this.document.getElementById('NoMachineLink').href = 'http://www.nomachine.com/download-client-solaris.php';
}

function disableLogin()
{
  if(this.document.Login.userName.disabled==false)
  {
    this.document.Login.userName.disabled=true;
    this.document.Login.password.disabled=true; 
    this.document.getElementById('nameText').style.color='#A1A5A9';
    this.document.getElementById('pwdText').style.color='#A1A5A9';     
  }
  else
  {
    this.document.Login.userName.disabled=false;
    this.document.Login.password.disabled=false;      
    this.document.getElementById('nameText').style.color='#514E53';
    this.document.getElementById('pwdText').style.color='#514E53';     
  }
}

//
// These functions realize the passage of options between the two select
// in add and modify user procedures.
//
function moveAllOptions(from,to) 
{
  selectAllOptions(from);
  if (arguments.length==2) 
  {
    moveSelectedOptions(from,to);
  }
  else if (arguments.length==3) 
  {
    moveSelectedOptions(from,to,arguments[2]);
  }
  else if (arguments.length==4) 
  {
    moveSelectedOptions(from,to,arguments[2],arguments[3]);
  }
}

function moveAllOptions1(from,to) 
{
  selectAllOptions(from);
  if (arguments.length==2) 
  {
    moveSelectedOptions1(from,to);
  }
  else if (arguments.length==3) 
  {
    moveSelectedOptions1(from,to,arguments[2]);
  }
  else if (arguments.length==4) 
  {
    moveSelectedOptions1(from,to,arguments[2],arguments[3]);
  }
}

function selectAllOptions(obj) 
{
  if (!hasOptions(obj)) { return; }
  for (var i=0; i<obj.options.length; i++) 
  {
    obj.options[i].selected = true;
  }
}

function sortSelect(obj) 
{
  var o = new Array();
  if (!hasOptions(obj)) { return; }
  for (var i=0; i<obj.options.length; i++) 
  {
    o[o.length] = new Option( obj.options[i].text, obj.options[i].value, obj.options[i].defaultSelected, obj.options[i].selected) ;
  }
  if (o.length==0) { return; }
  o = o.sort(
    function(a,b) {
      if ((a.text+"") < (b.text+"")) { return -1; }
      if ((a.text+"") > (b.text+"")) { return 1; }
      return 0;
      }
    );

  for (var i=0; i<o.length; i++) 
  {
    obj.options[i] = new Option(o[i].text, o[i].value, o[i].defaultSelected, o[i].selected);
  }
}

function hasOptions(obj) 
{
  if (obj!=null && obj.options!=null) { return true; }
  return false;
}

function moveSelectedOptions(from,to) 
{
  if (!hasOptions(from)) {return;}
  for (var i=0; i<from.options.length; i++) 
  {
    var o = from.options[i];
    if (o.selected) 
    {
      if (!hasOptions(to)) { var index = 0; } else { var index=to.options.length; }
      to.options[index] = new Option( o.text, o.value,true);
    }
  }
  // Delete them from original
  for (var i=(from.options.length-1); i>=0; i--) 
  {
    var o = from.options[i];
    if (o.selected) 
    {
      from.options[i] = null;
    }
  }
  if((from.options.length)==0)
  {
    this.document.create.add.disabled=true;
    this.document.create.allAdd.disabled=true;
    this.document.create.allAdd.style.backgroundImage='url(images/buttons/b_addAllDsb.gif)';
    this.document.create.add.style.backgroundImage='url(images/buttons/b_addPartialDsb.gif)';
  }
  if((from.options.length)>=0)
  {
    this.document.create.allRemove.style.backgroundImage='url(images/buttons/b_removeAll.gif)';
    this.document.create.remove.style.backgroundImage='url(images/buttons/b_removePartial.gif)';
    this.document.create.remove.disabled=false;
    this.document.create.allRemove.disabled=false;
  }

  sortSelect(from);
  sortSelect(to);
    
  from.selectedIndex = -1;
  to.selectedIndex = -1;
}

function moveSelectedOptions1(from,to) 
{
  // Move them over
  if (!hasOptions(from)) {return;}
  for (var i=0; i<from.options.length; i++) 
  {
    var o = from.options[i];
    if (o.selected) 
    {
      if (!hasOptions(to)) { var index = 0; } else { var index=to.options.length; }
      to.options[index] = new Option( o.text, o.value,true);
    }
  }
  // Delete them from original
  for (var i=(from.options.length-1); i>=0; i--) 
  {
    var o = from.options[i];
    if (o.selected) 
    {
      from.options[i] = null;
    }
  }
  if((from.options.length)==0)
  {
    this.document.create.remove.disabled=true;
    this.document.create.allRemove.disabled=true;
    this.document.create.allRemove.style.backgroundImage='url(images/buttons/b_removeAllDsb.gif)';
    this.document.create.remove.style.backgroundImage='url(images/buttons/b_removePartialDsb.gif)';
  }
  if((from.options.length)>=0)
  {
    this.document.create.allAdd.style.backgroundImage='url(images/buttons/b_addAll.gif)';
    this.document.create.add.style.backgroundImage='url(images/buttons/b_addPartial.gif)';
    this.document.create.add.disabled=false;
    this.document.create.allAdd.disabled=false;
  }
  sortSelect(from);
  sortSelect(to);
  from.selectedIndex = -1;
  to.selectedIndex = -1;
}

//
// These functions visualizes or hides some fields in AddServer and
// ModifyServer. 
//
  
function displaySuspendText()
{
  if(this.document.getElementById('suspendText').style.display=='block')
    this.document.getElementById('suspendText').style.display = 'none';
  else
    this.document.getElementById('suspendText').style.display='block';
}
function disableText()
{
  this.document.addServer.displayText.checked=false;
  this.document.addServer.substitutiveText.disabled=true;
  this.document.getElementById('replaceText').style.color='#A1A5A9';
  this.document.getElementById('noDisplayText').style.color='#514E53';
}
function disableNoDisplay()
{
  this.document.addServer.noDisplay.checked=false;
  this.document.getElementById('noDisplayText').style.color='#A1A5A9';
  this.document.getElementById('replaceText').style.color='#514E53';
  this.document.addServer.substitutiveText.disabled=false;
}

function enableRDP() 
{
  if(this.document.addServer.serverRDP.disabled == true)
  {
    this.document.getElementById('rdpText').style.color='#514E53';
    this.document.addServer.serverRDP.disabled=false; 
  }
  else
  {
    this.document.getElementById('rdpText').style.color='#A1A5A9';
    this.document.addServer.serverRDP.disabled=true; 
  }
}
  
function enableVNC() 
{
  if(this.document.addServer.serverVNC.disabled == true)
  {
    this.document.getElementById('vncText').style.color='#514E53';
    this.document.getElementById('vncText1').style.color='#514E53';
    this.document.getElementById('vncText2').style.color='#514E53';
    this.document.addServer.serverVNC.disabled=false;
    this.document.addServer.displayVNC.disabled=false;
    this.document.addServer.passwordVNC.disabled=false;
  } 
  else
  {
    this.document.getElementById('vncText').style.color='#A1A5A9';
    this.document.getElementById('vncText1').style.color='#A1A5A9';
    this.document.getElementById('vncText2').style.color='#A1A5A9';
    this.document.addServer.serverVNC.disabled=true;
    this.document.addServer.displayVNC.disabled=true;
    this.document.addServer.passwordVNC.disabled=true;
  }
}

function enableCustom() 
{
  if (this.document.addServer.command.disabled == true)
  {
    this.document.addServer.delCommand.style.backgroundImage='url(images/buttons/b_delCommand.gif)';
    this.document.addServer.delCommand.disabled=false;  
    this.document.addServer.addCommand.style.backgroundImage='url(images/buttons/b_addCommand.gif)';
    this.document.addServer.addCommand.disabled=false;  
    if (this.document.URL.indexOf('ModifyServer')!=-1)
    {
      this.document.addServer.updateCommand.style.backgroundImage='url(images/buttons/b_change.gif)';
      this.document.addServer.updateCommand.disabled=false;  
    }
    this.document.getElementById('selectCommand').disabled=false;  
    this.document.addServer.command.disabled=false;
    this.document.addServer.commandName.disabled=false;
    this.document.getElementById('commandText').style.color='#514E53';
    this.document.getElementById('commandNameText').style.color='#514E53';
  }
  else
  {
    this.document.addServer.delCommand.style.backgroundImage='url(images/buttons/b_delCommandDsb.gif)';
    this.document.addServer.delCommand.disabled=true;  
    this.document.addServer.addCommand.style.backgroundImage='url(images/buttons/b_addCommandDsb.gif)';
    this.document.addServer.addCommand.disabled=true;  
    if (this.document.URL.indexOf('ModifyServer')!=-1)
    {
      this.document.addServer.updateCommand.style.backgroundImage='url(images/buttons/b_changeDsb.gif)';
      this.document.addServer.updateCommand.disabled=true;  
    }
    this.document.getElementById('selectCommand').disabled=true;  
    this.document.addServer.command.disabled=true;
    this.document.addServer.commandName.disabled=true;
    this.document.getElementById('commandText').style.color='#A1A5A9';
    this.document.getElementById('commandNameText').style.color='#A1A5A9';
  }
}
  
function initiateVNC()
{
this.document.getElementById('vncText').style.color='#514E53';
    this.document.getElementById('vncText1').style.color='#514E53';
    this.document.getElementById('vncText2').style.color='#514E53';
    this.document.addServer.serverVNC.disabled=false;
    this.document.addServer.displayVNC.disabled=false;
    this.document.addServer.passwordVNC.disabled=false;
}

function initiateRDP()
{
  this.document.getElementById('rdpText').style.color='#514E53';
    this.document.addServer.serverRDP.disabled=false; 
}
function initiateCustom()
{
  this.document.addServer.delCommand.style.backgroundImage='url(images/buttons/b_delCommand.gif)';
  this.document.addServer.delCommand.disabled=false;  
  this.document.addServer.addCommand.style.backgroundImage='url(images/buttons/b_addCommand.gif)';
  this.document.addServer.addCommand.disabled=false;  
  if (this.document.URL.indexOf('ModifyServer')!=-1)
  {
    this.document.addServer.updateCommand.style.backgroundImage='url(images/buttons/b_change.gif)';
    this.document.addServer.updateCommand.disabled=false;  
  }
  this.document.getElementById('selectCommand').disabled=false;  
  this.document.addServer.command.disabled=false;
  this.document.getElementById('commandText').style.color='#514E53';
  this.document.addServer.commandName.disabled=false;
  this.document.getElementById('commandNameText').style.color='#514E53';
} 
function initiate()
{
  // disable CUSTOM
  if (this.document.addServer.command.disabled==false)
  {
  this.document.addServer.delCommand.style.backgroundImage='url(images/buttons/b_delCommandDsb.gif)';
  this.document.addServer.delCommand.disabled=true;  
  this.document.addServer.addCommand.style.backgroundImage='url(images/buttons/b_addCommandDsb.gif)';
  this.document.addServer.addCommand.disabled=true;  
  if (this.document.URL.indexOf('ModifyServer')!=-1)
  {
    this.document.addServer.updateCommand.style.backgroundImage='url(images/buttons/b_changeDsb.gif)';
    this.document.addServer.updateCommand.disabled=true;  
  }
  this.document.getElementById('selectCommand').disabled=true;  
  this.document.addServer.command.disabled=true;
  this.document.getElementById('commandText').style.color='#A1A5A9';
  this.document.addServer.commandName.disabled=true;
  this.document.getElementById('commandNameText').style.color='#A1A5A9';
  }
  // disable RDP
  if (this.document.addServer.serverRDP.disabled==false)
  {
  this.document.getElementById('rdpText').style.color='#A1A5A9';
  this.document.addServer.serverRDP.disabled=true; 
  }
  // disable VNC
  if (this.document.addServer.serverVNC.disabled==false)
  {
  this.document.getElementById('vncText').style.color='#A1A5A9';
  this.document.getElementById('vncText1').style.color='#A1A5A9';
  this.document.getElementById('vncText2').style.color='#A1A5A9';
  this.document.addServer.serverVNC.disabled=true;
  this.document.addServer.displayVNC.disabled=true;
  this.document.addServer.passwordVNC.disabled=true; 
  }
}
function initiate_start()
{
  this.document.getElementById('sessionRDP').style.display = 'none';
  this.document.getElementById('sessionVNC').style.display = 'none';
  this.document.getElementById('sessionCustom').style.display = 'none';
} 

//
// This function create an input dinamic.
//

function createOption()
{
  var sel=document.getElementById('selectCommand'); 
  if ( (document.getElementById('valueCustom').value != '') 
    && (document.getElementById('valueCustomName').value.indexOf("-")== -1) )
  {
    var flag=0;
    if ((document.getElementById('valueCustomName').value)!='')
      var val=this.document.getElementById('valueCustomName').value+'-'+this.document.getElementById('valueCustom').value;
    else
        var val=this.document.getElementById('valueCustom').value+'-'+this.document.getElementById('valueCustom').value;
    for (i=0; i<sel.options.length; i++)
    {
      if (sel.options[i].text == val)
        flag=1;
    }      
    if (!flag)
    {
      this.document.getElementById('valueCustom').value='';
      this.document.getElementById('valueCustomName').value='';
      sel.options[sel.options.length]= new Option (val, val, false);
      this.document.getElementById('valueCustom').focus();
    }
    else
    {
      alert('this command already exists');
    }
  }
  if (sel.options.length != 0)
  {
    this.document.addServer.delCommand.style.backgroundImage='url(images/buttons/b_delCommand.gif)';
    this.document.addServer.delCommand.disabled=false;   
  }
}

function deleteOption()
{
  var sel=document.getElementById('selectCommand');
  for (var i=sel.options.length-1; i>=0; i--) 
  {
    var o = sel.options[i];
    if (o.selected) 
      sel.remove(i);
  }
  if (sel.options.length == 0)
  {
    this.document.addServer.delCommand.style.backgroundImage='url(images/buttons/b_delCommandDsb.gif)';
    this.document.addServer.delCommand.disabled=true;  
  }
  this.document.getElementById('valueCustom').value='';
  this.document.getElementById('valueCustomName').value=''; 
}

function showInput(val)
{
	var index=this.document.getElementById('selectCommand').selectedIndex;
  command=val.split("-");
  com='';
  for (i=1;i<command.length;i++)
  {
	  if (i==1)
      com+=command[i];
    else   
      com+=' -'+command[i];
  }
  this.document.getElementById('valueCustomName').value=command[0];
  this.document.getElementById('valueCustom').value=com;
}

function updateOption()
{
	var index=this.document.getElementById('selectCommand').selectedIndex;
  if ( (document.getElementById('valueCustom').value != '') 
   && (document.getElementById('valueCustomName').value.indexOf("-")== -1) )
  {
    var sel=document.getElementById('selectCommand');    
    if ((document.getElementById('valueCustomName').value)!='')
      var val=this.document.getElementById('valueCustomName').value+'-'+this.document.getElementById('valueCustom').value;
    else
      var val=this.document.getElementById('valueCustom').value+'-'+this.document.getElementById('valueCustom').value;
    this.document.getElementById('valueCustom').value='';
    this.document.getElementById('valueCustomName').value='';
    sel.options[index].text=val;
    sel.options[index].value=val;
    this.document.getElementById('valueCustom').focus()
  }
  if (sel.options.length != 0)
  {
    this.document.addServer.delCommand.style.backgroundImage='url(images/buttons/b_delCommand.gif)';
    this.document.addServer.delCommand.disabled=false;   
  }
}

function showInfo(divId)
{
  if (divId.style.display=='block') 
    divId.style.display='none';
  else
    divId.style.display='block';
}

function displayAdministrator()
{
  if(this.document.getElementById('admin').style.display == 'block'){ 
    this.document.getElementById('admin').style.display = 'none'; 
    this.document.getElementById('serverAvailable').style.display = 'none'; 
  }
  else
  { 
    this.document.getElementById('serverAvailable').style.display = 'block';
    this.document.getElementById('admin').style.display = 'block';
  }
}

function selectAllServers()
{
  var len = this.document.create.server.length;

  for (i=0;i<this.document.create.server.length;i++)
  {
    this.document.create.server.options[i].selected = true;
  }
}
  
function selectAllSessions()
{
  for (i=0;i<(this.document.guest.sessionServer.length);i++)
  {
    divName='sessionServer-'+this.document.guest.sessionServer.options[i].text;
    selectName='sessionGuest-'+this.document.guest.sessionServer.options[i].text;
    if (this.document.getElementById(divName).style.display == 'block')
    {
      for (j=0;j<this.document.getElementById(selectName).length;j++)
        this.document.getElementById(selectName).options[j].selected = true;
    }
  }
}
  
function selectAllCommands()
{
  var sel= document.getElementById('selectCommand');
  var len = sel.options.length;
  for (i=0;i<len;i++)
  {
    sel.options[i].selected = true;
  }
}

function initiateAddUser()
{
  this.document.getElementById('serverAvailable').style.display = 'block';
  this.document.getElementById('admin').style.display = 'block';
}

function initiateModifyAdministrator()
{
  this.document.getElementById('serverAvailable').style.display = 'none'; 
  this.document.getElementById('admin').style.display = 'none';
}

function displayServerLabel()
{
  this.document.getElementById('serverLabel').style.display = 'none';
  this.document.getElementById('availableServerLabel').style.display = 'none';
}
//
// These functions realize the passage of options between the three
// select in add and modify guest procedures.
//
function showSessions(server)
{
  selectOptions();
  val=server.split("-");
  server=val[0];
  if (val[1]!='')
    icon=val[1];
  else 
    icon='imgEmpty.gif';  
  this.document.getElementById('serverIcon').src="images/shared/builder/imgEmpty.gif";
  l=this.document.guest.length;
  for(i=0;i<l;i++)
  {
    if(this.document.guest.elements[i].name.indexOf("sessionServer-") != -1)
      if (this.document.getElementById(this.document.guest.elements[i].name).style.display == 'block')
        this.document.getElementById(this.document.guest.elements[i].name).style.display='none';
  }
  this.document.getElementById('sessionServer-'+server).style.display='block';
  this.document.getElementById('serverIcon').src="images/shared/servers/"+icon;
}

function selectOptions()
{
  for (i=0;i<(document.guest.sessionServer.length);i++)
    {
      selectName='sessionGuest-'+document.guest.sessionServer.options[i].text;
      for (j=0;j<this.document.getElementById(selectName).length;j++)
        this.document.getElementById(selectName).options[j].selected = true;
      
    }
}
function moveSelectedSessions(from,to) 
{
  val=from.name.split("-");
    
  if (!hasOptions(from)) {return;}
  for (var i=0; i<from.options.length; i++) 
  {
    var o = from.options[i];
    if (o.selected) 
    {
      if (!hasOptions(to)) { var index = 0; } else { var index=to.options.length; }
      to.options[index] = new Option( o.text, o.value,true);
    }
  }
  for (var i=(from.options.length-1); i>=0; i--) 
  {
    var o = from.options[i];
    if (o.selected) 
    {
      from.options[i] = null;
    }
  }
  sortSelect(to);
  
  from.selectedIndex = -1;
  to.selectedIndex = -1;
  selectOptions()
}

function moveAllSessions(from,to) 
{
  selectAllOptions(from);
  moveSelectedSessions(from,to);
}
function showSessionIcon(icon)
{
  var id=this.document.guest.idUpload.value;
  this.document.getElementById('icon'+id).src='images/shared/sessions/'+icon;
}

function showSessionDetails(session)
{
  this.document.guest.icon.disabled=false;
  this.document.getElementById('uploadFileIcon').disabled=false;
  this.document.getElementById('assignFileIcon').disabled=false;
  this.document.getElementById('categoryText').disabled=false;
  this.document.guest.file1.disabled=false;
  l=this.document.guest.length;
  details=session.split('-');
  for(i=0;i<l;i++)
  {
    if(this.document.guest.elements[i].name.indexOf("iconSession") != -1)
    {
      divName=this.document.guest.elements[i].name;
      if (this.document.getElementById(divName).style.display == 'block')
        this.document.getElementById(this.document.guest.elements[i].name).style.display='none';
    }
  }
  this.document.getElementById('iconSessionEmpty').style.display='none';
  icon=this.document.guest.icon;
  image=this.document.getElementById('hiddenIcon'+details[1]).value;
  if(image == '')
    image='empty.gif';
  l=icon.length;
  for(i=0;i<l;i++)
  {
    if (icon.options[i].value==image)
    {
      icon.options[i].selected=true;
    } 
  }
  
  sessionName=this.document.getElementById('nameSession'+details[1]).value.split('-');
  app=sessionName[1].split('/'); 
  this.document.getElementById('sessionTitle').innerHTML="&nbsp;&nbsp;"+sessionName[0]+"-"+app[(app.length)-1];
  this.document.getElementById('iconSession'+details[1]).style.display='block';
  this.document.guest.idUpload.value=details[1];
  this.document.getElementById('b_browse').src="images/buttons/b_browse.gif";
}

function showIcon(idSession)
{
  this.document.guest.icon.disabled=false;
  this.document.getElementById('uploadFileIcon').disabled=false;
  this.document.getElementById('assignFileIcon').disabled=false;
  this.document.getElementById('categoryText').disabled=false;
  this.document.guest.file1.disabled=false;
  
  sessionName=this.document.getElementById('nameSession'+idSession).value.split('-');
  app=sessionName[1].split('/'); 
  this.document.getElementById('sessionTitle').innerHTML="&nbsp;&nbsp;"+sessionName[0]+"-"+app[(app.length)-1];
  
  icon=this.document.guest.icon;
  image=this.document.getElementById('hiddenIcon'+idSession).value;
  if(image == '')
    image='empty.gif';
  l=icon.length;
  for(i=0;i<l;i++)
  {
    if (icon.options[i].value==image)
    {
      icon.options[i].selected=true;
    } 
  }
  this.document.getElementById('iconSessionEmpty').style.display='none';
  this.document.getElementById('iconSession'+idSession).style.display='block';
  this.document.getElementById('b_browse').src="images/buttons/b_browse.gif";
  //
  // display select fields 
  //
  l=this.document.guest.length;
  for(i=0;i<l;i++)
  {
    if(this.document.guest.elements[i].name.indexOf("sessionServer-") != -1)
      if (this.document.getElementById(this.document.guest.elements[i].name).style.display == 'block')
        this.document.getElementById(this.document.guest.elements[i].name).style.display='none';
  }
  divName='sessionServer-'+sessionName[0];
  this.document.getElementById(divName).style.display='block';
  l=this.document.guest.sessionServer.length;
  for(i=0;i<l;i++)
  {
    if (this.document.guest.sessionServer.options[i].value.indexOf(sessionName[0])!=-1)
    {
      this.document.guest.sessionServer.options[i].selected=true;
    } 
  }
  
}

function disableResolution(radioRes)
{
  l=radioRes.length;
  for(i=0;i<l;i++)
  {
    radioRes[i].disabled=true;  
  }
}

function enableResolution(radioRes)
{
  l=radioRes.length;
  for(i=0;i<l;i++)
  {
    radioRes[i].disabled=false;  
  }
}

function showServerIcon(icon)
{
  this.document.getElementById('serverIcon').src='images/shared/servers/'+icon;
  this.document.getElementById('image').value='images/shared/servers/'+icon;
}

